package Desktop;

$ABSTRACT = "Desktop Environment";
$VERSION = '0.1';

package Desktop;
use Desktop::P;
use strict;

our %alias;

sub path_client {
  return coalesce($ENV{'MY_COMPUTER'},"$ENV{'HOME'}/System");
}

sub path_network {
  return coalesce($ENV{'MY_NETWORK'},"$ENV{'HOME'}/Network");
}

BEGIN {
%alias = (
	  "filesystems/my_network"=>"gnome-fs-network",

	  "filesystems/net_inet"=>"net_lan",
	  "filesystems/domain"=>"network",
	  "filesystems/workgroup"=>"gnome-fs-network",
	  "filesystems/smb_host"=>"server",
	  "filesystems/smb_share"=>"folder_green",
	  "filesystems/smb_master"=>"brain",
	  "filesystems/smb_host_browse"=>"find",
	  "filesystems/host"=>"server",
	  "filesystems/server"=>"server",
	  "filesystems/network"=>"network",
	  "filesystems/network_local"=>"network_local",
	  "devices/computer"=>"computer",

	  "services/ssh"=>"terminal",
	  "services/telnet"=>"terminal",
	  "services/telnets"=>"terminal",

	  "services/smtp"=>"korn",
	  "services/smtps"=>"korn",
	  "services/imap"=>"korn",
	  "services/imaps"=>"korn",
	  "services/pop3"=>"korn",
	  "services/pop3s"=>"korn",

	  "services/ftp"=>"folder",
	  "services/ftps"=>"folder",
	  "services/ftps-data"=>"folder",

	  "services/mythtv"=>"Television",

	  "services/ipp"=>"print_class",
	  "services/printer"=>"print_class",

	  "services/irc"=>"xchat",
	  "services/ircs"=>"xchat",
	  "services/irc-serv"=>"xchat",

	  "services/callbook"=>"personal",

	  "services/login"=>"login-photo",

	  "services/nfs"=>"nfs_mount",

	  "services/postgres"=>"postgresql",
	  "services/mysql"=>"FilingCabinet",

	  "services/shell"=>"terminal",

	  "services/rpcbind"=>"exec",
	  "services/exec"=>"exec",
	  "services/auth"=>"kuser",

	  "services/http"=>"html",
	  "services/http-alt"=>"html",
	  "services/http-proxy"=>"Network",
	  "services/https"=>"html",
	  "services/samba-swat"=>"samba",
	  "services/domain"=>"net_map",
	  "services/time"=>"clock",
	  "services/daytime"=>"clock",

	  "services/dict"=>"kdict",

	  "services/gdomap"=>"wmaker_apps",
	  "services/gdnc"=>"wmaker_apps",

	  "services/ppp"=>"kppp",
	  "services/jetdirect"=>"PrinterHP",

	  "services/netbios-ssn"=>"com-windows-xp",
	  "services/microsoft-ds"=>"com-windows-xp",

	  "services/java-or-OTGfileshare"=>"java",
	  "services/nessusd"=>"log", # net_monitor
	  "services/discard"=>"trashcan_empty", # net_monitor

	  "services/X11"=>"org-x",
	  "services/dhcpclient"=>"net_conf",

	  "services/news"=>"knewsticker",
	  "services/snews"=>"knewsticker",

	  "services/dc"=>"kfind",

	  "services/svrloc"=>"net_lan",

	  "services/socks"=>"password",

	  "services/mosmig"=>"EscherCube",
	  "services/omfs"=>"EscherCube",

	  "vendors/HP"=>"print_printer",
	  "vendors/Linux"=>"tux",
	  "vendors/Apple"=>"apple-mac-128",
	  "vendors/Microsoft"=>"com-windows-xp",
	  "vendors/Copper"=>"net_router",

	 );
}



use Data::Dumper;

sub alias {
  my $name=shift;
  if(defined($alias{$name})) { return $alias{$name}; };
  return $name;
}

sub Object {
  my $path=shift;
  my $isdir=shift;
  my $class=shift;
  my $template=shift;

  my $me;
  my $file;

  if($isdir) {
    unless(-d $path) { 
      mkdir $path; 
      print "mkdir $path\n";
    }
    $file=$path."/.directory";
  } else {
    $file=$path;
  }

  $me={'file'=>$file,
       'class'=>$class,
       'isdir'=>$isdir,
       'template'=>$template,
       @_};

  bless $me;
  $me->Set2("Icon","$class/$template");

  return $me;
}

sub Set2 { 
  my $me=shift; 
  $me->Set("Desktop Entry",@_); 
}

sub Set {
  my ($me,$section,$key,$val)=(@_);
  $me->{desktop}{$section}{$key}=$val;
}

sub Touch {
  my $me=shift;
  unless(-f $me->{file}) { $me->Save(0); }
  return $me;
}

sub Save {
  my $me    = shift;
  my $force = shift;

  if($me->{file}) {
    if(!$force && -f $me->{file}) { return 0; }
    print "cat - >$me->{file} <<'.'\n";

    if(open(fo,">$me->{file}")) {
      for my $section (keys(%{$me->{desktop}})) {
	print fo "[$section]\n";
	print "[$section]\n";
	for my $key (keys(%{$me->{desktop}{$section}})) {
	  print fo "$key=".alias($me->{desktop}{$section}{$key})."\n";
	  print "$key=".alias($me->{desktop}{$section}{$key})."\n";
	}
	print "\n";
      }

      close(fo);
    }
    print ".\n";
  }
}

1;

__END__
# Below is stub documentation for your module. You better edit it!

=head1 NAME

Desktop - Perl extension for desktop management

=head1 SYNOPSIS

  use Desktop;

=head1 DESCRIPTION

This is desktop library and utilities.


=head2 EXPORT

None by default.


=head1 AUTHOR

=head1 SEE ALSO

=pod

=cut
